package com.views.properties.tabbed;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.jface.viewers.IStructuredContentProvider;
import org.eclipse.jface.viewers.ITreeContentProvider;
import org.eclipse.jface.viewers.TreeViewer;
import org.eclipse.jface.viewers.Viewer;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Listener;


public class PlayComposite extends Composite {

    private TreeViewer treeViewer;

    private TreeNode root;
    
    public PlayComposite(Composite parent) {
        super(parent, SWT.NONE);
        createPlayComposite();

    }
    
    private void createPlayComposite() {
    	this.setLayout(new GridLayout());
        Button button = new Button(this, SWT.NONE);
		button.setBounds(20, 35, 40, 25);
		button.setText("Click to Add");
		button.addListener(SWT.Selection, listener);
		
        treeViewer = new TreeViewer(this, SWT.NONE);
         
        treeViewer.setAutoExpandLevel(2);

        treeViewer.setContentProvider(new TreeContentProvider());
        treeViewer.setInput(getRootNode());
    }

    class TreeContentProvider implements IStructuredContentProvider,
            ITreeContentProvider {

        public void dispose() {
        }

        public Object[] getChildren(Object parentElement) {
            return ((TreeNode) parentElement).getChildren().toArray();
        }

        public Object getParent(Object element) {
            return ((TreeNode) element).getParent();
        }

        public boolean hasChildren(Object element) {
            return ((TreeNode) element).getChildren().size() > 0;
        }

        public Object[] getElements(Object inputElement) {
            return ((TreeNode) inputElement).getChildren().toArray();
        }

        public void inputChanged(Viewer viewer, Object oldInput, Object newInput) {
        }

    }
    
    Listener listener = new Listener() {
    	private int i;
		public void handleEvent(Event event) {
			root.addChild(new TreeNode("child " + i++));
			treeViewer.setInput(root);
		}
	};

    private TreeNode getRootNode() {
        root = new TreeNode("root");
        return root;
    }

    class TreeNode {
        private String name;
        private List<TreeNode> children = new ArrayList<TreeNode>();
        private TreeNode parent;

        public TreeNode(String n) {
            name = n;
        }

        protected Object getParent() {
            return parent;
        }

        public TreeNode addChild(TreeNode child) {
            children.add(child);
            child.parent = this;
            return this;
        }

        public List<TreeNode> getChildren() {
            return children;
        }

        public String toString() {
            return name;
        }
    }

}
